const metaTag = document.getElementById('ks-meta');
const metaString = metaTag.innerText;
const meta = JSON.parse(metaString);
const {
  websocketsPort
} = meta;
// an extra check in case the meta tag is wrong
const isReallyInIframe = window.parent !== window;
if (websocketsPort) {
  if ('WebSocket' in window && window.location.hostname === 'localhost') {
    const socket = new window.WebSocket(`ws://localhost:${websocketsPort}`);
    socket.addEventListener('message', msg => {
      const theMsg = JSON.parse(msg?.data ?? {});
      if (!theMsg?.event) return;
      const event = theMsg.event;
      switch (event) {
        case 'RENDERER_CLIENT_RELOAD':
          window.location.reload();
          break;
      }
    });
  }
}
if (isReallyInIframe) {
  /**
   * Prevents the natural click behavior of any links within the iframe.
   * Otherwise the iframe reloads with the current page or follows the url provided.
   */
  const links = document.querySelectorAll('a');
  links.forEach(link => {
    link.addEventListener('click', e => {
      e.preventDefault();
    });
  });
  let timeoutId;

  /**
   * Sends a message to the parent window with the current height and width of the iframe's content.
   * Search code base for the value in `event.type` to see how it's used.
   */
  function sendResizeEvent(_ref) {
    let {
      height,
      width
    } = _ref;
    clearTimeout(timeoutId);
    // slight delay to prevent spamming the parent window with resize events
    timeoutId = setTimeout(() => {
      const event = {
        type: 'ksRendererClient.contentResized',
        // round up to the nearest pixel
        height: Math.ceil(height),
        width: Math.ceil(width)
      };
      window.parent.postMessage(event, '*');
    }, 100);
  }
  if (ResizeObserver) {
    // watch for any changes to the content's width/height
    const resizeObserver = new ResizeObserver(entries => {
      const [entry] = entries;
      if (!entry) return;
      const {
        height,
        width
      } = entry.contentRect;
      sendResizeEvent({
        height,
        width
      });
    });

    // watch the <body> element
    resizeObserver.observe(document.body);
  }
}
